import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { Url, UrlParam } from './model';
import {SERVER_API_URL} from '@/config/index';

/**
 * 分页查询应用域名
 */
export async function pageUrl(params: UrlParam) {
  const res = await request.get<ApiResult<PageResult<Url>>>(
    SERVER_API_URL + '/system/url/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询应用域名列表
 */
export async function listUrl(params?: UrlParam) {
  const res = await request.get<ApiResult<Url[]>>(
    SERVER_API_URL + '/system/url',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加应用域名
 */
export async function addUrl(data: Url) {
  const res = await request.post<ApiResult<unknown>>(
    SERVER_API_URL + '/system/url',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改应用域名
 */
export async function updateUrl(data: Url) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/url',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除应用域名
 */
export async function removeUrl(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/url/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除应用域名
 */
export async function removeBatchUrl(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/url/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询应用域名
 */
export async function getUrl(id: number) {
  const res = await request.get<ApiResult<Url>>(
    SERVER_API_URL + '/system/url/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
